# #
# $Date: 1996/06/20 12:51:43 $  $Author: frankp $   $Revision: 1.13 $ #
# #
# frankp, 30/03/95 #

#++
  eigenval.mu

	linalg::eigenValues -- computes the eigenvalues of a matrix

	linalg::eigenValues(A [,{All,Multiple}])
	
	A: square matrix
	 
	The call eigenValues(A) returns a list of the eigenvalues of A.
	If option All or Multiple is given, then a list of sublists 
        is returned, where each sublist contains an eigenvalue and its 
        algebraic multiplicity.

	If the coefficient ring of A is Float then a numerical
	solver will be used.
++#

linalg::eigenValues := proc(A)
    name linalg::eigenValues;
    option remember;
    local p, ____eigenValue_x, R, Opt;
begin
    if testargs() then
        if args(0) < 1 or args(0) > 2 then
	    error("wrong no of args")
	end_if;
	if A::hasProp( Cat::MatrixCat ) <> TRUE then
	    error("expecting a matrix")
	end_if;
	if args(0) = 2 then
	    if args(2) <> hold(All) and args(2) <> hold(Multiple) then
		error("expecting option 'All' or 'Multiple'")
	    end_if
	end_if
    end_if;

    if args(0) = 2 then Opt:= hold(Multiple) else Opt:= null() end_if;

    R:= A::coeffRing;
    p:= linalg::charPolynomial( A,____eigenValue_x );
    if R = Dom::Float then
	map( float(hold(solve)(expr(p),____eigenValue_x,Opt)),R::convert ) 
	   minus {FAIL}
    elif args(0) = 2 then
	solve(p,____eigenValue_x=A::coeffRing,Opt)
    else
	solve(p,____eigenValue_x=A::coeffRing)
    end_if
end_proc:

# end of file #
