# $Date: 1996/07/02 17:18:26 $ $Author: kraume $ $Revision: 1.10 $ #

# kg, 27/12/94 #

#++
userinfo -- print information for user

userinfo(lev,epxr...)

lev  - level of information (positive integer)
expr - expression to print

'userinfo' prints its arguments 'expr...' to the screen if either the
"information level" of the procedure or domain calling 'userinfo' or
 the "global information level" is greater or equal to 'lev'.

The information level (of a procedure or domain or the global one) is defined 
via 'setuserinfo'. The default level is 0, ie. no information is printed.

The procedure calling 'userinfo' is determined via 'procname'. This
may cause problems is 'procname' doesn't contain the expected value.
++#

userinfo:= fun((
  if stdlib::userinfo_level <> FAIL
    then if contains(stdlib::userinfo_level, procname)
           then case type(context(args(1)))
                  of DOM_INT  do
   	            if context(args(1)) <= stdlib::userinfo_level[procname]
                      then PRETTY_PRINT;
		           PRETTY_PRINT:= FALSE;
                           if stdlib::userinfo_level[procname, 1]
                             then print(Unquoted,procname,context(args(2..args(0))));
                             else print(Unquoted,         context(args(2..args(0))));
                           end_if;
		           PRETTY_PRINT:= %3;
	            end_if; break;
                  of "_range" do
   	            if op(context(args(1)),1)<= stdlib::userinfo_level[procname] and op(context(args(1)),2)>= stdlib::userinfo_level[procname]
                      then PRETTY_PRINT;
		           PRETTY_PRINT:= FALSE;
		           if stdlib::userinfo_level[procname, 1]
                             then print(Unquoted,procname,context(args(2..args(0))));
                             else print(Unquoted,         context(args(2..args(0))));
                           end_if;
		           PRETTY_PRINT:= %3;
	            end_if;
                end_case; 
           elif type(procname)="domattr" and contains(stdlib::userinfo_level, op(procname,1))
             then case type(context(args(1)))
                    of DOM_INT  do
   	              if context(args(1)) <= stdlib::userinfo_level[op(procname,1)]
                        then PRETTY_PRINT;
		             PRETTY_PRINT:= FALSE;
		             if stdlib::userinfo_level[op(procname,1), 1]
                               then print(Unquoted,procname,context(args(2..args(0))));
                               else print(Unquoted,         context(args(2..args(0))));
                             end_if;
		             PRETTY_PRINT:= %3;
	              end_if; break;
                    of "_range" do
                      if op(context(args(1)),1)<= stdlib::userinfo_level[op(procname,1)] and op(context(args(1)),2)>= stdlib::userinfo_level[op(procname,1)]
                        then PRETTY_PRINT;
		             PRETTY_PRINT:= FALSE;
		             if stdlib::userinfo_level[op(procname,1), 1]
                               then print(Unquoted,procname,context(args(2..args(0))));
                               else print(Unquoted,         context(args(2..args(0))));
                             end_if;
		             PRETTY_PRINT:= %3;
	              end_if;
                  end_case;
	   elif contains(stdlib::userinfo_level, hold(Any))
             then case type(context(args(1)))
                    of DOM_INT  do
   	              if context(args(1)) <= stdlib::userinfo_level[hold(Any)]
                        then PRETTY_PRINT;
                             PRETTY_PRINT:= FALSE;
		             if stdlib::userinfo_level[hold(Any), 1]
                               then print(Unquoted,procname,context(args(2..args(0))));
                               else print(Unquoted,         context(args(2..args(0))));
                              end_if;
		              PRETTY_PRINT:= %3;
	               end_if; break;
                     of "_range" do
   	               if op(context(args(1)),1)<= stdlib::userinfo_level[hold(Any)] and op(context(args(1)),2)>= stdlib::userinfo_level[hold(Any)]
                         then PRETTY_PRINT;
		              PRETTY_PRINT:= FALSE;
		              if stdlib::userinfo_level[hold(Any), 1]
                                then print(Unquoted,procname,context(args(2..args(0))));
                                else print(Unquoted,         context(args(2..args(0))));
                              end_if;
		              PRETTY_PRINT:= %3;
	               end_if;
                   end_case;
            end_if;
  end_if;
  null() ),hold):

# end of file #
