/* $Date: 1996/10/30 14:41:34 $  $Author: tonner $  $Revision: 1.20 $ */

/**************************************************************************/
/* FILE:             MIO_local.h                                          */
/* Autor:            Oliver Kluge, Andreas Kemper, Ralf Hillebrand        */ 
/* Erstellt:         18/08/92                                             */ 
/* Letzte Aenderung: 07/08/94                                             */ 
/**************************************************************************/ 
 
#ifndef __MIO_local__
#define __MIO_local__


/**************************************************************************/ 
/* Dieses File enthaelt die internen Routinen der Ausgabe .               */  
/**************************************************************************/ 
 
#define MIONULL ((MIOV_PRETTY_PRINT)?MIO_out_make_text(0L,0L,0L,NO_SYM_BIT,"")\
		:MMMNULL)


/* Wie MDB_make_debug_info, nur ist der Schluessel bereits bekannt und 
   nicht der Filename */

#define MIO_make_debug_info( line, key, valid )   \
	( line << SHIFT | key << 1 | valid )

#define MIO_create_info( line )		\
	MDB_create_debug_info( MIO_make_debug_info( line, MIOV_KEY, 1) )

/* Macros zur Erstellung eines tempor"aren Feldes von 'num'-char-Werten */

#define MIO_new_string(l, sp, num)                                    \
	{ sp = MMMmalloc(MMMCglobal,MMM_TMP,sizeof(char)*(num+1), 0L);     \
          *MMMarr(&sp,num,char,MMMwrite) = '\0';    \
	  l = MMMZ(&sp,char,MMMwrite);                                   \
	  MMMpoolinsert(&l); }


#define MIO_free_string(l, sp)                                        \
        { MMMpooldelete(&l);						 \
	  MMMfree(sp); }



/****************** Funktionen in den Dateien MIO_*.c **********************/

S_Pointer MIO_out_args(S_Pointer *);
S_Pointer MIO_out_args_expr(S_Pointer *,long,S_Pointer);
S_Pointer MIO_out_all_args (S_Pointer, MUPbool) ;

S_Pointer MIO_out_plus(S_Pointer,S_Pointer,long,S_Pointer);
S_Pointer MIO_out_mult(S_Pointer,S_Pointer,long,S_Pointer);
S_Pointer MIO_out_power(S_Pointer,S_Pointer,long,S_Pointer);
S_Pointer MIO_out_index_args(S_Pointer,long);
S_Pointer MIO_out_stmtseq(S_Pointer,S_Pointer,long,S_Pointer);

short  MIO_out_stmt(S_Pointer *,long,S_Pointer);
S_Pointer MIO_init_stmt(VOID);
void MIO_exit_stmt(VOID);
void MIO_print_blanks(long,MUPbool);
S_Pointer MIO_call_eval(S_Pointer, S_Pointer);

S_Pointer MIO_out_help(S_Pointer *);
S_Pointer MIO_out_make_node(MIOT_FIELDSIZE, MIOT_FIELDSIZE, MIOT_FIELDSIZE, MIOT_FIELDSIZE, long);
S_Pointer MIO_out_make_text(MIOT_FIELDSIZE, MIOT_FIELDSIZE, MIOT_FIELDSIZE, MIOT_FIELDSIZE, char *);
S_Pointer MIO_out_make_field(MIOT_FIELDSIZE);
S_Pointer MIO_out_category(S_Pointer *,long,S_Pointer);
void MIO_out_print_line(MIOT_FIELDSIZE);
S_Pointer MIO_out_write_line(MIOT_FIELDSIZE);
S_Pointer MIO_out_vertical_line(MIOT_FIELDSIZE);
void MIO_out_write_in_field(S_Pointer , MIOT_FIELDSIZE , MIOT_FIELDSIZE *);
void MIO_out_node_to_field(S_Pointer , MIOT_FIELDSIZE , MIOT_FIELDSIZE *);
void MIO_out_text_to_field(S_Pointer , MIOT_FIELDSIZE , MIOT_FIELDSIZE *);
S_Pointer MIO_del_trailing_zeroes(S_Pointer);
S_Pointer MIO_miostring2mmmstring(S_Pointer);

S_Pointer MIO_out_node(S_Pointer *,long,S_Pointer);
S_Pointer MIO_out_expr(S_Pointer *,long,S_Pointer);
S_Pointer MIO_out_brackets(S_Pointer, char);
S_Pointer MIO_open_bracket(MIOT_FIELDSIZE ,char);
S_Pointer MIO_close_bracket(MIOT_FIELDSIZE ,char);
S_Pointer MIO_out_evaluate_children(S_Pointer ,long ,long , S_Pointer); 
S_Pointer MIO_out_special_exprseq(S_Pointer);
void MIO_make_STRING_BUFFER(S_Pointer);
S_Pointer MIO_flush_STRING_BUFFER(VOID);
void MIO_make_NUM_BUFFER(S_Pointer);
S_Pointer MIO_flush_NUM_BUFFER(VOID);
void MIO_newline(VOID);
void MIO_open_line(VOID);
void MIO_close_line(VOID);
void MIO_make_FIELD_BUFFER(S_Pointer);

void MIO_put_pointer(S_Pointer,S_Pointer,long);
void MIO_get_param(S_Pointer,MIOT_FIELDSIZE *,MIOT_FIELDSIZE *,MIOT_FIELDSIZE *,MIOT_FIELDSIZE *);
void MIO_put_param(S_Pointer,MIOT_FIELDSIZE,MIOT_FIELDSIZE,MIOT_FIELDSIZE,MIOT_FIELDSIZE spec);
void MIO_get_pos(S_Pointer,long,MIOT_FIELDSIZE *line,MIOT_FIELDSIZE *);
void MIO_put_pos(S_Pointer,long,MIOT_FIELDSIZE,MIOT_FIELDSIZE );
S_Pointer MIO_not(S_Pointer);
S_Pointer MIO_div(S_Pointer);
S_Pointer MIO_minus(S_Pointer, long, long);
S_Pointer MIO_bracket(S_Pointer);
void MIO_init_BLOCK(VOID);
void MIO_exit_BLOCK(VOID);

/* globale Variable in den Ausgabefiles  */


extern S_Pointer (*MIOV_JumpTab[MUPC_MaxCatTypes])(S_Pointer, long priority);  /* Sprungtabelle fuer unter - */                                           /* schiedliche Kategorien     */


extern MUPbool MIOV_PRINT_NUMBER;	/* Steuerung der Zahlausgabe bei PRETTY_PRINT */
extern MUPbool MIOV_PRINT_STRING;	/* Steuerung der Stringausgabe bei PRETTY_PRINT */
extern MUPbool MIOV_PRINT_BLOCK;         /* Flag fuer die Art der Ausgabe bei PRETTY_PRINT */
extern MUPbool MIOV_PRINT_STMT;          /* Flag fuer die Art der Ausgabe bei PRETTY_PRINT */
extern MIOT_FIELDSIZE MIOV_STRINGLEN;       /* Stringlaenge bei PRETTY_PRINT */

#ifdef MDX

#ifndef DOS_FILENAMES
#  include "MDB_debug.h"
#else
#  include "MDB_debu.h"
#endif

extern MUPbool  MIOV_DEBUG_MODE;   /* steuert die Erzeugung von Debug-Info's */
extern MUPbool  MIOV_REALLY_DEBUG; /* steuert die Erzeugung von Debug-Info's */
extern long     MIOV_LINES;        /* Aktuelle Zeilennummer fuer Debug-Mode */
extern long     MIOV_KEY;               /* Nummer der Ausgabedatei fuer Debug-Mode*/
extern DBX_TYPE MIOV_GLOBAL_DBX;	   /* letzte Debug-Info */
extern long 	MIOV_NUM_STMTSEQ;	   /* Rekursionstiefe der STMTSEQes */
extern MUPbool  MIOV_EXPR2TEXT_MODE;

#endif


extern int XMUPAD;

/* Anzahl der Zeichen, die in der aktuellen Zeile bisher ausgegeben wurden */

extern long MIOV_ACT_LEN;

enum OPERATOR { PLUS  , MULT , POWER, STMTSEQ , STAND_OP };

/* Routinen des Files MIO_array.c */


void MIO_out_array_head(long dim,long *start,long *range,long *div);
	               

S_Pointer
MIO_out_divided_array(	S_Pointer    s,
			long         dim, 
			long        *start, 
			long        *range,
			long	    *div);

S_Pointer
MIO_out_undivided_array(S_Pointer    s,
			long         dim, 
			long        *start, 
			long        *range,
			long	    *div);

S_Pointer	
MIO_out_divided_array_pretty(	S_Pointer     s,
		 		long          dim, 
	        		long         *start,
				long         *end,
		 		long 	     *div, 
		 		long         *actblock, 
				long	     *maxblock,
		 		long         *subrange,
		 		long         *offset,
		 		long         *actpos);

void	
MIO_out_divided_array_without_pretty(	S_Pointer     s,
		 		long          dim, 
	        		long         *start,
				long         *end,
		 		long 	     *div, 
		 		long         *actblock, 
				long	     *maxblock,
		 		long         *subrange,
		 		long         *offset,
		 		long         *actpos);	

S_Pointer	
MIO_out_divided_matrix(	S_Pointer     s,
		 	long          dim, 
	       		long         *start,
			long         *end,
		 	long 	     *div, 
		 	long         *actblock, 
			long	     *maxblock,
	 		long         *subrange,
		 	long         *offset,
		 	long         *actpos);


S_Pointer	
MIO_out_undivided_array_pretty(	S_Pointer     s,
		 		long          dim, 
	        		long         *start,
				long         *end,
				long  	     *div,
		 		long         *actpos);

void	
MIO_out_undivided_array_without_pretty(	S_Pointer     s,
		 		long          dim, 
	        		long         *start,
				long         *end,
				long  	     *div,
		 		long         *actpos);

S_Pointer	
MIO_out_undivided_matrix(	S_Pointer     s,
		 		long          dim, 
	        		long         *start,
				long         *end,
		 		long         *actpos);

void	
MIO_out_subarray(S_Pointer     list,
		 long          dim, 
	         long         *start,
		 long         *end,
		 long 	      *div, 
		 long         *actblock, 
		 long         *subrange,
		 long         *offset,
		 long         *actpos);		
 	
#endif /* __MIO_local__ */
 
